dojo.provide("com.ibm.mm.builder.systemwidget.Navigation");
dojo.require("com.ibm.mm.builder.navigationHelper");
dojo.require("dojo.dnd.Source");
dojo.require("dijit.form.ValidationTextBox");
dojo.require("com.ibm.dnd.PageCreator");
dojo.require("com.ibm.widgets.NavigationWidget");
dojo.require("com.ibm.widgets.NewPageDialog");
dojo.require("dojo.i18n");
dojo.require("com.ibm.domUtilities");
dojo.requireLocalization("com.ibm.bundles","NavWidget");
dojo.requireLocalization("com.ibm.mm.builder","coreWidgetsMessages");
dojo.declare("com.ibm.mm.builder.systemwidget.Navigation",null,{globalPageOpened:null,isSwitching:false,globalPageLoaded:false,openGlobalPageAgain:false,onLoad:function(){
if(!com.ibm.mm.builder.navigationHelper.loaded){
com.ibm.mm.builder.navigationHelper.init();
}
this.navigationUtil=com.ibm.mm.builder.utils.navigationUtil;
this.pageUtil=com.ibm.mm.builder.utils.pageUtil;
this.themeUtil=com.ibm.mm.builder.utils.themeUtil;
this.spaceUtil=com.ibm.mm.builder.utils.spaceUtil;
this.navigationModel=this.navigationUtil.getNavigationModel();
com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService").subscribeEvent("com.ibm.mashups.enabler.model.state.onNavStateUpdated",this,function(){
var _1=this.pageUtil.getCurrentPageId();
var _2=this.pageUtil.getPageIdFromSpace();
if(_1!==_2&&!this.isSwitching&&(!this.globalPageLoaded||this.openGlobalPageAgain)){
if(this.openGlobalPageAgain){
this.openGlobalPageAgain=false;
}
this.onSwitchPage({payload:_2});
}
});
this._initNavigation();
this.LOGGER=com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.systemwidget.Navigation");
},_initNavigation:function(){
this.startTabLevel=parseInt(this.iContext.getiWidgetAttributes().getItemValue("startLevel"),10);
var _3=dojo.i18n.getLocalization("com.ibm.bundles","NavWidget");
var _4=this.pageUtil.getCurrentPageNode();
this.tabNavigation=new com.ibm.widgets.NavigationWidget({model:com.ibm.mm.builder.navigationHelper.getTreeModel(),item:_4,openDelay:0,selectionModel:com.ibm.mm.builder.navigationHelper.getSelectionModel(),tiedToSelection:true,level:this.startTabLevel,closeDelay:500,popupDelay:0,dndEnabled:this.pageUtil.canEdit(_4),dndType:"cmNode",dndAccept:"cmNode",dndCreator:com.ibm.dnd.PAGE_CREATOR.creator,showInlineEditor:!com.ibm.mm.builder.utils.userUtil.isLockedDownAnonymousMode()&&(this.spaceUtil.canEdit(this.spaceUtil.getCurrentSpaceNode())||this.spaceUtil.isPersonalSpace()),inlineEditorLabel:_3.nav_new_page_label,inlineEditorDefaultValue:_3.nav_new_page_default_value,nestedInlineEditorLabel:_3.nav_new_page_nested_label,emptyContentsInlineEditorLabel:_3.nav_new_page_empty_nested_label,inlineEditorTitle:_3.nav_new_page_title,embeddedEditorPopup:"com.ibm.widgets.NewPageDialog",embeddedEditorPopupParams:{showMakePrivate:false,showFriendlyURL:false,blankImg:ibmConfig.themeBasePath+"css/images/blank.gif"},baseClass:"",tabListClass:"lotusTabs",tabClass:"",selectedClass:"lotusSelected",setupInlineEditor:function(){
if(this.item.hasRole("Privileged User")||this.item.hasRole("Editor")){
this.inherited("setupInlineEditor",arguments);
}
},onModelItemClick:function(_5,_6){
var cb=dojo.hitch(this,function(){
var es=com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
es.broadcastEvent("com.ibm.mashups.builder.switchPage",this.model.getIdentity(_6));
});
com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(cb);
}},"navigationContainer");
this.tabNavigation.startup();
com.ibm.mm.builder.TabbedNavigationDelegate=this;
},onSwitchPage:function(_7){
this.tabNavigation.disableDnd();
if(this.globalPageLoaded&&_7.payload&&com.ibm.mm.builder.utils.spaceUtil.getSpaceIdByPageId(_7.payload)!=this.globalPageLoadedSpaceId){
if(_7.payload!=this.globalPageOpened){
this.onClearGlobalPage();
}else{
}
}
var cb=dojo.hitch(this,function(){
this.isSwitching=true;
try{
this.tabNavigation.level=com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId()?this.startTabLevel+1:this.startTabLevel;
this.pageUtil.updatePageTitle();
this.refresh(_7.payload,true);
}
catch(e){
var _8=dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_NAV_PANE_POSTCREATE_1,[e.message]);
this.LOGGER.severe("onSwitchPage",_8);
}
this.isSwitching=false;
this.handleOnSwitchPage(_7);
});
com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(cb);
},handleOnSwitchPage:function(_9){
},onRefreshNavigation:function(_a){
try{
this.refresh(_a.payload);
}
catch(e){
var _b=dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_NAV_REFRESH_NAVIGATION_1,[e.message]);
this.LOGGER.severe("onRefreshNavigation",_b);
}
},refresh:function(_c,_d){
var _e=null;
if((_c!==null)&&(_c===this.globalPageOpened)&&(com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId()===this.globalPageLoadedSpaceId)){
_e=this.navigationModel.find(_c).start();
this.tabNavigation.selectionModel.changeSelection(_e);
this.tabNavigation.reload();
if(this.pageUtil.canEdit(_e)){
this.tabNavigation.setupDnd();
}
if(_d){
this.pageUtil.setPageId(_c);
com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setID(_c);
com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.pageSwitched",_c);
}
this.globalPageLoaded=true;
}else{
var _f=this.pageUtil.getCurrentPageId();
var _10=this._isNavigationCreated(_c);
var _11=location.href;
if(_10){
if(this.themeUtil.getThemeId()!=this.themeUtil.getCurrentThemeId()){
var _12=this.pageUtil.getCurrentPageId();
this.pageUtil.setPageId(_12);
var _13=this.navigationUtil.getRedirectAddress();
setTimeout(function(){
if(_13===_11.replace(/pid=([^&]*)/,"pid="+_12)){
location.reload();
}else{
location.href=_13;
}
},10);
return;
}
if(!_f){
_d=true;
}
}else{
if(this.themeUtil.getCurrentSpaceThemeId()!=this.themeUtil.getCurrentThemeId()){
this.pageUtil.setPageId();
setTimeout(function(){
window.location.reload();
},10);
return;
}
}
if(_c===null){
_c=com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
if(!_c){
var _14=this.spaceUtil.getCurrentSpaceId();
_c=_14?this.pageUtil.getFirstPageInSpace(_14):this.pageUtil.getFirstRootPageId();
}
}
if(_c!==null){
_e=this.navigationModel.find(_c).start();
com.ibm.mm.builder.navigationHelper.getSelectionModel().changeSelection(_e);
this.tabNavigation.showInlineEditor=this.spaceUtil.canEdit(this.spaceUtil.getCurrentSpaceNode());
this.tabNavigation.reload();
if(this.pageUtil.canEdit(_e)){
this.tabNavigation.setupDnd();
}
}else{
this.tabNavigation.selectionModel.selectionPath=[this.spaceUtil.getCurrentSpaceNode(),this.navigationUtil.getNavigationRootNode()];
var _15=this.spaceUtil.getCurrentSpaceNode();
this.tabNavigation.item=_15;
this.tabNavigation.reload();
if(this.pageUtil.canEdit(_15)){
this.tabNavigation.setupDnd();
}
}
if(_d){
com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
this.pageUtil.setPageId(_c);
com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.pageSwitched",_c);
}
}
},_isNavigationCreated:function(pid){
var _16=false;
var _17=com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage();
var _18=null;
pid=pid||_17.getID();
if(!pid){
_18=this.spaceUtil.getCurrentSpaceId();
pid=_18?this.pageUtil.getFirstPageInSpace(_18):this.pageUtil.getFirstRootPageId();
}
if(!pid){
return null;
}
_17.setID(pid);
_18=this.spaceUtil.getSpaceIdByPageId(pid);
if(_18!==this.spaceUtil.getCurrentSpaceId()){
this.spaceUtil.setSpaceId(_18);
}
var _19=[];
var _1a=this.navigationUtil.getNavigationModel();
var _1b=_1a.find(pid).start();
var _1c=this.navigationUtil.getNavigationRootNodeId();
var _1d=this.navigationUtil.getNavigationRootNodeId(this.spaceUtil.getCurrentSpaceId());
while(_1b&&_1b.getID()!==_1c&&_1b.getID()!==_1d){
_19.push(_1b);
_1b=_1a.getParent(_1b.getID()).start();
}
if(_19.length===0){
return false;
}
return true;
},onOpenPage:function(_1e){
var es=com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
var cb=dojo.hitch(this,function(){
if(this.globalPageOpened){
if(this.globalPageOpened==(_1e.payload||_1e.payload.pid)){
if(this.globalPageOpened==com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID()){
console.log("Error: you are now already in the global page you want to open");
return;
}
this.openGlobalPageAgain=true;
var cb=dojo.hitch(this,function(){
com.ibm.mm.builder.utils.pageUtil.changePageMode("view");
es.broadcastEvents(_1e.payload.eventsArray||[],this.lastVisitedPage,this.globalPageOpened);
});
com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(cb);
}else{
var _1f={closePageId:this.globalPageOpened,openPagePayload:_1e.payload};
es.broadcastEvent("com.ibm.mashups.builder.closePage",_1f);
}
}else{
if(dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid)){
this.lastVisitedPage=dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid);
}else{
this.lastVisitedPage=com.ibm.mm.builder.utils.pageUtil.getCurrentPageId();
}
this.globalPageLoadedSpaceId=com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId();
if(_1e.payload.pid){
this.globalPageOpened=_1e.payload.pid;
}else{
this.globalPageOpened=_1e.payload;
}
dojo.cookie(com.ibm.mm.builder.constant.cookieKey_globalPageId,this.globalPageOpened);
dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid,this.lastVisitedPage,{expires:3652});
dojo.cookie(com.ibm.mm.builder.constant.cookieKey_globalPageOpenedSpaceId,this.globalPageLoadedSpaceId);
if(this.lastVisitedPage===this.globalPageOpened){
console.log("Error: you already in global page, please close it.");
return;
}
var _20=com.ibm.mm.builder.utils.pageUtil.getPageNode(this.globalPageOpened);
var _21=this.tabNavigation.model;
var _22;
var _23=function(_24){
_22=_24;
};
var _25=function(){
};
_21.getRoot(_23,_25);
var _26={title:_20.getTitle(dojo.locale),pageLoadedSpaceId:this.globalPageLoadedSpaceId,openPageId:this.globalPageOpened};
if(_1e.payload.pid){
_26.eventsArray=_1e.payload.eventsArray;
_26.lastVisitedPage=this.lastVisitedPage;
}
_21.newItem(_26,_21.getParent(_22));
}
});
com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(cb);
},onClosePage:function(_27){
var _28=null;
if(_27.payload.closePageId){
_28=_27.payload.closePageId;
}else{
_28=_27.payload;
}
if(_28!=this.globalPageOpened){
console.log("Error: you are closing a global page not opened now!");
return;
}
if(this.globalPageOpened){
var _29=com.ibm.mm.builder.utils.pageUtil.getPageNode(this.globalPageOpened);
var _2a=this.tabNavigation.model;
var _2b={"lastVisitedPage":this.lastVisitedPage};
if(_27.payload.openPagePayload){
_2b.openPagePayload=_27.payload.openPagePayload;
}
this.globalPageOpened=null;
this.lastVisitedPage=null;
this.globalPageLoadedSpaceId=null;
this.globalPageLoaded=false;
_2a.deleteItem(_2b,_29);
dojo.cookie(com.ibm.mm.builder.constant.cookieKey_globalPageId,null,{expires:-1});
dojo.cookie(com.ibm.mm.builder.constant.cookieKey_globalPageOpenedSpaceId,null,{expires:-1});
if(_2b.openPagePayload){
this.tabNavigation.reload();
var es=com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
es.broadcastEvent("com.ibm.mashups.builder.openPage",_2b.openPagePayload);
}else{
dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid,null,{expires:-1});
}
}else{
console.log("Error: the global page is not open, can't close it.");
}
},onClearGlobalPage:function(){
if(this.globalPageOpened){
var _2c=com.ibm.mm.builder.utils.pageUtil.getPageNode(this.globalPageOpened);
var _2d=this.tabNavigation.model;
this.globalPageOpened=null;
this.lastVisitedPage=null;
this.globalPageLoadedSpaceId=null;
this.globalPageLoaded=false;
var _2e={"lastVisitedPage":this.lastVisitedPage};
_2d.clearGlobalPageItem(_2e,_2c);
dojo.cookie(com.ibm.mm.builder.constant.cookieKey_globalPageId,null,{expires:-1});
dojo.cookie(com.ibm.mm.builder.constant.cookieKey_globalPageOpenedSpaceId,null,{expires:-1});
dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid,null,{expires:-1});
}
},onUnload:function(){
if(this.tabNavigation!==null){
this.tabNavigation.destroy();
this.tabNavigation=null;
}
}});

