dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.utilities");
dojo.require("com.ibm.pb.iwidget.iWidgetBase");
dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.bundles","Shelf");
dojo.declare("com.ibm.mm.builder.pageToolbarButtons",[dijit._Widget,dijit._Templated,com.ibm.pb.iwidget.iWidgetBase],{saveDisabled:false,containersHidden:true,fadeTime:500,newPage:false,shelfId:null,noTemplateLayout:false,hiddenName:"ibmHiddenWidgets",editModeClass:"edit-mode",layoutMetadataKey:"com.ibm.portal.layout.template.ref",layoutFileMetadataKey:"com.ibm.portal.static.page.file.name.html",templateString:"<div class=\"lotusBtnContainer lotusui\" dojoAttachPoint=\"buttonContainer\" style=\"display:none;height:auto;\" role=\"toolbar\">"+"<button class=\"lotusBtn lotusBtnDisabled\" aria-disabled=\"true\" role=\"button\" dojoAttachPoint=\"customizeButton\" dojoAttachEvent=\"onclick:showOrHideCustomize\" href=\"javascript:void(0)\">${customizeString}</button>"+"<button class=\"lotusBtn\" aria-disabled=\"false\" role=\"button\" dojoAttachPoint=\"hiddenButton\" dojoAttachEvent=\"onclick:showOrHideContainers\" href=\"javascript:void(0)\" title=\"${showHiddenString}\">${hiddenString}</button>"+"<button class=\"lotusBtn lotusHidden\" aria-disabled=\"false\" role=\"button\" dojoAttachPoint=\"savePageButton\" dojoAttachEvent=\"onclick:savePage\" href=\"javascript:void(0)\">${saveString}</button>"+"<button class=\"lotusBtn\" aria-disabled=\"false\" role=\"button\" dojoAttachPoint=\"saveAndExitButton\" dojoAttachEvent=\"onclick:savePageAndExit\" href=\"javascript:void(0)\">${saveAndExitString}</button>"+"<button class=\"lotusBtn\" aria-disabled=\"false\" role=\"button\" dojoAttachPoint=\"cancelButton\" dojoAttachEvent=\"onclick:cancelAll\" href=\"javascript:void(0)\">${cancelString}</button>"+"</div>",onLoad:function(){
var _1,_2=this.iContext.getiWidgetAttributes().getItemValue("rootDomId");
if(_2){
_1=dojo.byId(_2);
}
if(!_1){
_1=dojo.query("."+com.ibm.mm.builder.constant.iwWidgetContent,this.iContext.getRootElement())[0];
}
if(_1){
_1.appendChild(this.domNode);
}else{
this.iContext.getRootElement().appendChild(this.domNode);
}
this.shelfId=this.iContext.getiWidgetAttributes().getItemValue("shelfId");
this.noTemplateLayout=this.iContext.getiWidgetAttributes().getItemValue("noTemplateLayout");
if(!this.iContext.getiWidgetAttributes().getItemValue("hideSaveBtn")){
dojo.removeClass(this.savePageButton,"lotusHidden");
}
},postMixInProperties:function(){
var _3=dojo.i18n.getLocalization("com.ibm.bundles","Shelf");
this.customizeString=_3["shelf_customize"];
this.hiddenString=_3["shelf_hiddenContainers"];
this.hideHiddenString=_3["shelf_hideHiddenContainers"];
this.showHiddenString=_3["shelf_showHiddenContainers"];
this.saveString=_3["shelf_saveChanges"];
this.saveAndExitString=_3["shelf_saveAndExit"];
this.cancelString=_3["add_content_cancel"];
},postCreate:function(){
this.fadeIn=dojo.fx.wipeIn({node:this.buttonContainer,duration:this.fadeTime});
this.fadeOut=dojo.fx.wipeOut({node:this.buttonContainer,duration:this.fadeTime});
},showOrHideCustomize:function(){
if(!this.shelf){
this.shelf=dijit.byId(this.shelfId);
}
if(this.shelf){
this.shelf.link=this.customizeButton;
if(this._isButtonEnabled(this.customizeButton)){
this.shelf.toggleDisplay();
}
}
},showOrHideContainers:function(){
if(this.noTemplateLayout){
var _4=dojo.query("[name^='"+this.hiddenName+"']");
if(_4.length<1){
return;
}
var _5=_4[0];
if(this.containersHidden){
_5.style.display="block";
this.containersHidden=false;
this.onViewHiddenWidgets();
}else{
_5.style.display="none";
this.containersHidden=true;
this.onHideHiddenWidgets();
}
}else{
if(this.containersHidden){
this.evtSvc.broadcastEvent("com.ibm.mashups.builder.viewHiddenWidgets");
}else{
this.evtSvc.broadcastEvent("com.ibm.mashups.builder.hideHiddenWidgets");
}
}
},savePage:function(){
if(!this.saveDisabled){
this.evtSvc.broadcastEvent("com.ibm.mashups.builder.savePage");
}
},savePageAndExit:function(){
this.savePage();
if(!this.saveDisabled){
if(ibmCfg.themeConfig.isPageRenderModeCSA){
this._broadcastModeChange("view");
}else{
var me=this;
setTimeout(function(){
me._broadcastModeChange("view");
},500);
}
}
},cancelAll:function(){
var _6=com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
var _7=com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage();
if(_7.isDirty()){
if(!this.shelf){
this.shelf=dijit.byId(this.shelfId);
}
this.shelf.undoChildren();
if(ibmCfg.themeConfig.alwaysRefreshOnPageSave){
window.onbeforeunload=null;
top.location.reload();
}else{
var _8=_7.getID();
var _9=com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
var _a=_9.find(_8).start();
_9.invalidate(_a);
com.ibm.mashups.enabler.widget.Factory.getWidgetModel().cachedWindows={};
var _b=com.ibm.mashups.enabler.model.state.AccessorFactory.getLayoutAccessor(_6,_8);
_b.setTemplateURL(null);
var _c=com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
_c.broadcastEvent("com.ibm.mashups.builder.layoutRefresh");
_7.setDirty(false);
}
}
this._broadcastModeChange("view");
},onPageSwitched:function(_d){
var _e=com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getPageMode();
if((this.newPage&&_e=="view")||(!this.newPage&&_e=="edit")){
this._broadcastModeChange(this.newPage?"edit":"view");
this.newPage=false;
}
if(this._canCustomize()){
this._enableButton(this.customizeButton);
}else{
this._disableButton(this.customizeButton);
}
if(this.page.getNavigationElementType()==com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_PAGE){
var _f=this.page.getContent().start();
if(!_f.getMetaData(this.layoutMetadataKey)){
this._hideButton(this.hiddenButton);
}else{
this._showButton(this.hiddenButton);
}
}
},onPageCreated:function(_10){
},onPageModeChanged:function(_11){
if(this._canCustomize()){
this._enableButton(this.customizeButton);
}else{
this._disableButton(this.customizeButton);
}
if(_11.payload=="edit"){
if(this.page.getNavigationElementType()==com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_PAGE){
var _12=this.page.getContent().start();
if(!_12.getMetaData(this.layoutMetadataKey)){
this._hideButton(this.hiddenButton);
}else{
this._showButton(this.hiddenButton);
}
}else{
this._hideButton(this.hiddenButton);
}
}
if(_11.payload=="edit"){
dojo.addClass(dojo.body(),this.editModeClass);
if(!dojo.isIE&&!dojo.isFF){
this.fadeIn.play();
}else{
this.buttonContainer.style.display="";
}
}else{
if(!this.containersHidden){
this.showOrHideContainers();
}
dojo.removeClass(dojo.body(),this.editModeClass);
if(!dojo.isIE&&!dojo.isFF){
this.fadeOut.play();
}else{
this.buttonContainer.style.display="none";
}
}
},onViewHiddenWidgets:function(){
this.hiddenButton.title=this.hideHiddenString;
dojo.addClass(this.hiddenButton,"ibmCompressed");
this.containersHidden=false;
},onHideHiddenWidgets:function(){
this.hiddenButton.title=this.showHiddenString;
dojo.removeClass(this.hiddenButton,"ibmCompressed");
this.containersHidden=true;
},onview:function(){
},onUnload:function(){
},_broadcastModeChange:function(_13){
var _14="_broadcastModeChange";
this.LOGGER.entering(_14,arguments);
var _15=com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getPageMode();
var _16=com.ibm.mashups.enabler.user.Factory.getUserModel();
if(_16.getAnonymousMode()!=com.ibm.mashups.enabler.user.AnonymousMode.ANONYMOUS&&_15!=_13){
this.LOGGER.trace(_14,"Broadcasting mode change to ${0}",[_13]);
if(dojo.isSafari||dojo.isOpera){
var me=this;
setTimeout(function(){
me.evtSvc.broadcastEvent("com.ibm.mashups.builder.changePageMode",_13);
},500);
}else{
this.evtSvc.broadcastEvent("com.ibm.mashups.builder.changePageMode",_13);
}
com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setPageMode(_13);
}
this.LOGGER.exiting(_14,arguments);
},_canCustomize:function(){
var _17=com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
var _18=com.ibm.mashups.enabler.navigation.Factory.getNavigationModel().find(_17);
if(_18){
this.page=_18.start();
var _19=this.page.getContent().start();
if(_19.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR)||_19.hasRole(com.ibm.mashups.enabler.ac.RoleType.ADMIN)){
return true;
}else{
if(_19.hasRole("Privileged User")){
if(!_19.getMetaData(this.layoutMetadataKey)&&!_19.getMetaData(this.layoutFileMetadataKey)){
return false;
}else{
return true;
}
}else{
return false;
}
}
}else{
return false;
}
},_isButtonEnabled:function(_1a){
return !dojo.hasClass(_1a,"lotusBtnDisabled");
},_disableButton:function(_1b){
dojo.addClass(_1b,"lotusBtnDisabled");
dojo.attr(_1b,"aria-disabled","true");
},_enableButton:function(_1c){
dojo.removeClass(_1c,"lotusBtnDisabled");
dojo.attr(_1c,"aria-disabled","false");
},_hideButton:function(_1d){
dojo.addClass(_1d,"lotusHidden");
},_showButton:function(_1e){
dojo.removeClass(_1e,"lotusHidden");
},_onPageDirty:function(){
this.saveDisabled=false;
this._enableButton(this.savePageButton);
this._enableButton(this.saveAndExitButton);
this._enableButton(this.cancelButton);
},_onPageClean:function(){
this.saveDisabled=true;
this._disableButton(this.savePageButton);
this._disableButton(this.saveAndExitButton);
this._disableButton(this.cancelButton);
}});

